import 'package:flutter/material.dart';

class Badge extends StatelessWidget {
  final Widget child;
  final String text;
  final TextStyle textStyle;
  final double right;
  final double top;
  final double constraintSize;
  final double padding;
  final Color color;
  final double borderRadius;
  final bool visibility;

  Badge({
    @required this.child,
    @required this.text,
    this.textStyle,
    this.right = 0.0,
    this.top = 0.0,
    this.constraintSize = 12.0,
    this.padding = 0.0,
    this.color = Colors.green,
    this.borderRadius = 8.0,
    this.visibility = true
  });

  @override
  Widget build(BuildContext context) {
    if(visibility) {
      return Stack(
        children: [
          child,
          Positioned(
            right: right,
            top: top,
            child: Container(
              padding: EdgeInsets.all(padding),
              decoration: BoxDecoration(
                color: color,
                borderRadius: BorderRadius.circular(borderRadius),
              ),
              constraints: BoxConstraints(
                minWidth: constraintSize,
                minHeight: constraintSize,
              ),
              child: Center(
                child: Text(text,
                  style: TextStyle(
                    color: Colors.white,
                    fontSize: 8,
                  ).merge(textStyle),
                  textAlign: TextAlign.center,
                ),
              ),
            ),
          )
        ],
      );
    }
    return child;
  }
}