import 'package:flutter/material.dart';

class CancelButton extends StatelessWidget {
  final double iconRadius;
  final Color iconColor;
  final Color backgroundColor;
  final Function onTapHandler;

  CancelButton({
    this.iconRadius = 14.0,
    this.iconColor = Colors.grey,
    this.backgroundColor = Colors.transparent,
    @required this.onTapHandler,
  });

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () => onTapHandler(),
      child: Align(
        alignment: Alignment.topRight,
        child: CircleAvatar(
          radius: iconRadius,
          /*
              * On Purpose white color is given besides background being white,
              * as ahead if we want to style it with circle shape and icon
              * inside then that is possible with just providing required color here
              */
          backgroundColor: backgroundColor,
          child: Icon(Icons.close, color: iconColor),
        ),
      ),
    );
  }
}
