part of 'custom_fab.dart';

class CustomFabOption extends StatelessWidget {
  final String label;
  final int fabNumber;
  final bool isSelected;
  final GestureTapCallback onPressed;
  final Color selectedColor;
  final Color unselectedColor;

  const CustomFabOption({
    Key key,
    @required this.label,
    @required this.fabNumber,
    this.isSelected = false,
    @required this.onPressed,
    @required this.selectedColor,
    @required this.unselectedColor,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Row(
      children: [
        Spacer(),
        GestureDetector(
          onTap: onPressed,
          child: Container(
            padding: EdgeInsets.fromLTRB(10, 3, 3, 3),
            margin: EdgeInsets.all(5),
            decoration: BoxDecoration(
              color: LIGHT_GREY_4,
              borderRadius: BorderRadius.circular(30),
              boxShadow: [
                BoxShadow(
                  color: Colors.grey[700],
                  offset: Offset(3, 5),
                  blurRadius: 5,
                ),
              ],
            ),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.end,
              children: [
                Text(
                  label,
                  style: Theme.of(context).textTheme.subtitle2.copyWith(color: _getColorBasedOnSelectionStatus()),
                ),
                SizedBox(width: 5),
                CircleAvatar(
                  backgroundColor: _getColorBasedOnSelectionStatus(),
                  child: Text(
                    fabNumber.toString(),
                    style: Theme.of(context).textTheme.headline5.copyWith(color: Colors.white),
                  ),
                ),
              ],
            ),
          ),
        ),
      ],
    );
  }

  Color _getColorBasedOnSelectionStatus() {
    return isSelected ? selectedColor : unselectedColor;
  }
}
