import 'package:flutter/material.dart';
import 'package:vegigo2_ui_common/theme/theme_gradient.dart';

class PrimaryButton extends StatelessWidget {
  final String title;
  final double width;
  final VoidCallback onButtonPressed;
  final Color textColor;

  const PrimaryButton({
    Key key,
    @required this.title,
    this.width = 150.0,
    this.onButtonPressed,
    this.textColor = Colors.black,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return RaisedButton(
      onPressed: onButtonPressed,
      padding: const EdgeInsets.all(0.0),
      elevation: 3.0,
      shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(31.0)),
      child: Ink(
        decoration: BoxDecoration(
          gradient: ThemeGradient(context: context),
          borderRadius: BorderRadius.circular(31.0),
        ),
        width: width,
        padding: const EdgeInsets.symmetric(horizontal: 22.0, vertical: 10.0),
        child: Center(
          child: Text(
            title.toUpperCase(),
            style: Theme.of(context).textTheme.headline4.copyWith(color: textColor),
          ),
        ),
      ),
    );
  }
}
