import 'package:equatable/equatable.dart';
import 'package:meta/meta.dart';
import 'package:vegigo2_ui_common/entities/product/unit_price_mapping.dart';

class OrderProduct extends Equatable {
  final String id;
  final String productId;
  final String title;
  final String thumbnail;
  final double discountRatio;
  final int quantity;
  final UnitPriceMapping unitPriceMapping;
  final OrderProductCategory productCategory;

  OrderProduct({
    @required this.id,
    @required this.productId,
    @required this.title,
    @required this.thumbnail,
    @required this.discountRatio,
    @required this.quantity,
    @required this.unitPriceMapping,
    @required this.productCategory,
  });

  @override
  List<Object> get props => <Object>[id, title, thumbnail, quantity, unitPriceMapping, productCategory];
}

class OrderProductCategory extends Equatable {
  final String id;
  final String title;

  OrderProductCategory({
    @required this.id,
    @required this.title
  });

  @override
  List<Object> get props => <Object>[id, title];
}