import 'package:geolocator/geolocator.dart';
import 'package:vegigo2_ui_common/error/messages.dart';

abstract class LocationInfo {
  Future<Position> currentLocation();
}

class LocationInfoImpl implements LocationInfo {
  Future<Position> currentLocation() async {
    bool serviceEnabled = await Geolocator.isLocationServiceEnabled();
    if (!serviceEnabled) {
      Geolocator.openLocationSettings();
    }
    await Geolocator.requestPermission();
    LocationPermission permission = await Geolocator.checkPermission();
    if (permission == LocationPermission.denied || permission == LocationPermission.deniedForever) {
      throw Exception(LOCATION_PERMISSION_ERROR);
    }
    return Geolocator.getCurrentPosition(desiredAccuracy: LocationAccuracy.high);
  }
}
