import 'package:meta/meta.dart';
import 'package:vegigo2_ui_common/entities/product/product_category.dart';
import 'package:vegigo2_ui_common/models/product/unit_model.dart';

class ProductCategoryModel extends ProductCategory {
  ProductCategoryModel({
    @required String id,
    @required String title,
    @required String thumbnail,
    @required List<UnitModel> units,
  }) : super(
    id: id,
    title: title,
    thumbnail: thumbnail,
    units: units,
  );

  factory ProductCategoryModel.fromJson(Map<String, dynamic> json) =>
    ProductCategoryModel(
      id: json['id'].toString(),
      title: json['title'] as String,
      thumbnail: json['thumbnail'] as String,
      units: UnitModel.fromJsonArray(json['units'] as List<dynamic>),
    );

  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'title': title,
      'thumbnail': thumbnail,
      'units': units.map((unit) => (unit as UnitModel).toJson()).toList()
    };
  }

  static List<ProductCategoryModel> fromJsonArray(List<dynamic> jsonArray) {
    return jsonArray.map((jsonProductCategory) => ProductCategoryModel.fromJson(jsonProductCategory as Map<String, dynamic>)).toList();
  }

  static List<Map<String, dynamic>> toJsonArray(List<ProductCategoryModel> productCategories) {
    return productCategories.map((productCategory) => productCategory.toJson()).toList();
  }
}