import 'package:meta/meta.dart';
import 'package:vegigo2_ui_common/entities/product/unit.dart';

class UnitModel extends Unit {
  UnitModel({
    @required String id,
    @required String title,
    @required String abbr
  }) : super(
    id: id,
    title: title,
    abbr: abbr,
  );

  factory UnitModel.fromJson(Map<String, dynamic> json) =>
    UnitModel(
      id: json['id'].toString(),
      title: json['title'] as String,
      abbr: json['abbr'] as String,
    );

  Map<String, dynamic> toJson() => {
    'id': id,
    'title': title,
    'abbr': abbr,
  };

  static List<UnitModel> fromJsonArray(List<dynamic> jsonArray) {
    return jsonArray.map((jsonUnit) => UnitModel.fromJson(jsonUnit as Map<String, dynamic>)).toList();
  }

  static List<Map<String, dynamic>> toJsonArray(List<UnitModel> units) {
    return units.map((UnitModel unit) => unit.toJson()).toList();
  }
}