import 'package:meta/meta.dart';
import 'package:vegigo2_ui_common/entities/entities.dart';
import 'package:vegigo2_ui_common/entities/store/delivery_policy.dart';

class DeliveryPolicyModel extends DeliveryPolicy {

  DeliveryPolicyModel({
    @required String id,
    @required double charges,
    @required double activationAmount,
    @required String description,
    @required String store,
    @required bool active,
  }) : super(
    id: id,
    charges: charges,
    activationAmount:activationAmount,
    description: description,
    store: store,
    active: active
  );

  factory DeliveryPolicyModel.fromJson(Map<String, dynamic> json) {
    return DeliveryPolicyModel(
      id: json['id'].toString(),
      charges: json['charges'] as double,
      activationAmount: json['activationAmount'] as double,
      description: json['description'] as String,
      store: json['store'] as String,
      active: json['active'] as bool,
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'charges': charges,
      'activationAmount': activationAmount,
      'description': description,
      'store': store,
      'active': active
    };
  }

  static List<DeliveryPolicyModel> fromJsonArray(List<dynamic> jsonArray) {
    return jsonArray.map((jsonProduct) => DeliveryPolicyModel.fromJson(jsonProduct as Map<String, dynamic>)).toList();
  }

  static List<Map<String, dynamic>> toJsonArray(List<DeliveryPolicyModel> deliveryPolicies) {
    return deliveryPolicies.map((policy) => policy.toJson()).toList();
  }
}